<html>
<head>
<title>OgreGpuProgramManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGpuProgramManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGpuProgramManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GpuProgramManager_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GpuProgramManager_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResourceManager_8h.html">OgreResourceManager.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00046"></a><a class="code" href="classOgre_1_1GpuProgramManager.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;GpuProgramManager&gt;
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a39cb435674c75c8e6b5f9e8aeebe6ec9">00050</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;String&gt;::type</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#a39cb435674c75c8e6b5f9e8aeebe6ec9">SyntaxCodes</a>;
<a name="l00051"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a3a0eb9f6c60a3650de8b5d842d30a1fb">00051</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, GpuSharedParametersPtr&gt;::type</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#a3a0eb9f6c60a3650de8b5d842d30a1fb">SharedParametersMap</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#aef34af73ab87b0b09d2707ebeb43508d">00053</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">MemoryDataStreamPtr</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#aef34af73ab87b0b09d2707ebeb43508d">Microcode</a>;
<a name="l00054"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a2a6028b6d23b3dea967da49f2b23e3bc">00054</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, Microcode&gt;::type</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#a2a6028b6d23b3dea967da49f2b23e3bc">MicrocodeMap</a>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keyword">protected</span>:
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a8daf06956d7a7c36a4c262f2f3c2d54c">00058</a>         <a class="code" href="classOgre_1_1GpuProgramManager.html#a3a0eb9f6c60a3650de8b5d842d30a1fb">SharedParametersMap</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#a8daf06956d7a7c36a4c262f2f3c2d54c">mSharedParametersMap</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a56415ef2a5a21e425d0141902749d886">00059</a>         <a class="code" href="classOgre_1_1GpuProgramManager.html#a2a6028b6d23b3dea967da49f2b23e3bc">MicrocodeMap</a> <a class="code" href="classOgre_1_1GpuProgramManager.html#a56415ef2a5a21e425d0141902749d886">mMicrocodeCache</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1GpuProgramManager.html#a4653eb83ff12cf95f3abcc6d952dab64">00060</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GpuProgramManager.html#a4653eb83ff12cf95f3abcc6d952dab64">mSaveMicrocodesToCache</a>;
<a name="l00061"></a>00061             
<a name="l00062"></a>00062         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> addRenderSystemToName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;  name );
<a name="l00063"></a>00063 
<a name="l00065"></a>00065         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>* createImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle, 
<a name="l00066"></a>00066             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader,
<a name="l00067"></a>00067             <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode) = 0;
<a name="l00068"></a>00068     <span class="keyword">public</span>:
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a>();
<a name="l00070"></a>00070         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a>();
<a name="l00071"></a>00071 
<a name="l00083"></a>00083         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> load(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, 
<a name="l00084"></a>00084             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, 
<a name="l00085"></a>00085             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode);
<a name="l00086"></a>00086 
<a name="l00098"></a>00098         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> loadFromString(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName,
<a name="l00099"></a>00099             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; code, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype,
<a name="l00100"></a>00100             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode);
<a name="l00101"></a>00101 
<a name="l00103"></a>00103         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramManager.html#a39cb435674c75c8e6b5f9e8aeebe6ec9">SyntaxCodes</a>&amp; getSupportedSyntax(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00104"></a>00104          
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isSyntaxSupported(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode) <span class="keyword">const</span>;
<a name="l00108"></a>00108         
<a name="l00114"></a>00114         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> createParameters(<span class="keywordtype">void</span>);
<a name="l00115"></a>00115         
<a name="l00130"></a>00130         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> createProgram(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00131"></a>00131             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename, 
<a name="l00132"></a>00132             <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode);
<a name="l00133"></a>00133 
<a name="l00148"></a>00148         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> createProgramFromString(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00149"></a>00149             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; code, 
<a name="l00150"></a>00150             <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode);
<a name="l00151"></a>00151 
<a name="l00155"></a>00155         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> create(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, 
<a name="l00156"></a>00156             <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; syntaxCode, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00157"></a>00157             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00158"></a>00158 
<a name="l00164"></a>00164         <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> getByName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">bool</span> preferHighLevelPrograms = <span class="keyword">true</span>);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00172"></a>00172         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuSharedParametersPtr</a> createSharedParameters(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00173"></a>00173 
<a name="l00177"></a>00177         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html">GpuSharedParametersPtr</a> getSharedParameters(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00178"></a>00178 
<a name="l00181"></a>00181         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramManager.html#a3a0eb9f6c60a3650de8b5d842d30a1fb">SharedParametersMap</a>&amp; getAvailableSharedParameters() <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00185"></a>00185         <span class="keywordtype">bool</span> getSaveMicrocodesToCache();
<a name="l00188"></a>00188         <span class="keywordtype">void</span> setSaveMicrocodesToCache( <span class="keyword">const</span> <span class="keywordtype">bool</span> val );
<a name="l00189"></a>00189 
<a name="l00190"></a>00190         <span class="keywordtype">bool</span> canGetCompiledShaderBuffer();
<a name="l00194"></a>00194         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isMicrocodeAvailableInCache( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name ) <span class="keyword">const</span>;
<a name="l00198"></a>00198         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">Microcode</a> &amp; getMicrocodeFromCache( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name ) <span class="keyword">const</span>;
<a name="l00199"></a>00199 
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">Microcode</a> createMicrocode( <span class="keyword">const</span> <span class="keywordtype">size_t</span> size ) <span class="keyword">const</span>;
<a name="l00204"></a>00204 
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addMicrocodeToCache( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">Microcode</a> &amp; microcode );
<a name="l00209"></a>00209 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <span class="keywordtype">void</span> saveMicrocodeCache( <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream ) <span class="keyword">const</span>;
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadMicrocodeCache( <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream );
<a name="l00218"></a>00218         
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00236"></a>00236         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00252"></a>00252         <span class="keyword">static</span> <a class="code" href="classOgre_1_1GpuProgramManager.html">GpuProgramManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00253"></a>00253     
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     };
<a name="l00257"></a>00257 
<a name="l00260"></a>00260 }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
